
//------------------------------------------------------------------*/

#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  RoyalBlue
#property  indicator_color2  Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_minimum 0.0
#property indicator_maximum 1.0

//-------------------------------------------------------------------
extern int period=34;
extern bool alarm=false;
extern int nBars = 500;

//-------------------------------------------------------------------

double         ExtBuffer0[];
double         ExtBuffer1[];
double         ExtBuffer2[];
double alertBar;
double last;

int init()
{  
   IndicatorDigits(0);
   IndicatorBuffers(3);

   SetIndexStyle (0,DRAW_HISTOGRAM, EMPTY,4,RoyalBlue);
   SetIndexBuffer(0,ExtBuffer1);
   SetIndexStyle (1,DRAW_HISTOGRAM, EMPTY,4,Red);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexBuffer(2,ExtBuffer0);

   IndicatorShortName("SSL" +" ("+period+")");
   SetIndexLabel(0,"Trend UP");
   SetIndexLabel(1,"Trend DN");

   return(0);
  }


int start()
{
   int    limit;
//   int    counted_bars=IndicatorCounted();
   double prev=0,current;
   double Value=0,Fish1=0;
   double price;
   double MinL=0;
   double MaxH=0;  
   

//   if(counted_bars>0) counted_bars--;
//   limit=Bars-counted_bars;

limit = nBars;
   //for(int i=0; i<Bars; i++)
   for(int i=0; i<limit; i++) {
      MaxH = High[Highest(NULL,0,MODE_HIGH,period,i)];
      MinL = Low[Lowest(NULL,0,MODE_LOW,period,i)];
      price = (High[i]+Low[i])/2;
      
      if(MaxH-MinL == 0)
         Value = 0.33*2*(0-0.5) + 0.67*prev; 
      else
         Value = 0.33*2*((price-MinL)/(MaxH-MinL)-0.5) + 0.67*prev;     
      
      Value=MathMin(MathMax(Value,-0.999),0.999); 
      
      if(1-Value == 0)
         ExtBuffer0[i]=0.5+0.5*Fish1;
      else
         ExtBuffer0[i]=0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1;
     
      prev=Value;
      Fish1=ExtBuffer0[i];
   }


   bool trendUP = TRUE;
   for (int j = limit-1; j >= 0; j--) {
      current = ExtBuffer0[j];
      prev    = ExtBuffer0[j + 1];
      
      if ((current < 0.0 && prev > 0.0) || current < 0.0)
         trendUP = FALSE;
      if ((current > 0.0 && prev < 0.0) || current > 0.0)
         trendUP = TRUE;
      
      if (trendUP) {
         ExtBuffer1[j] = 1.0;
         ExtBuffer2[j] = EMPTY_VALUE;
         if (alarm == true) {
            if (j==0 && prev != 2 && ExtBuffer1[j] == 1.0 && Bars>alertBar) {
               Alert("(smVorti) Trend Changing Down on ",Period()," ",Symbol());
               alertBar = Bars;
               last = 2;
            }
         }
      } 
      
      else {
         ExtBuffer2[j] = 1.0;
         ExtBuffer1[j] = EMPTY_VALUE;
         if (alarm == true) {
            if (j==0 && last != 1 && ExtBuffer2[j] == 1.0 && Bars>alertBar) {
               Alert("(smVorti) Trend Changing Up on ",Period()," ",Symbol());
               alertBar = Bars;
               last = 1;
            }
         }
      }
   }
   return(0);
}